<template>
  <div id="app">
    <v-app>
      <v-main>
        <v-theme-provider>
          <v-container>
            <v-row justify="center" class="ma-5">
              <v-col xs="12" sm="8">
                <v-card>
                  <v-toolbar color="blue darken-4" dark>
                    <v-toolbar-side-icon></v-toolbar-side-icon>
                    <v-toolbar-title class="headline">Todo App</v-toolbar-title>

                    <v-spacer></v-spacer>
                  </v-toolbar>

                  <v-list two-line subheader>
                    <v-list-item>
                      <v-list-item-content>
                        <v-list-item-title>
                          <v-text-field
                            v-model="newTodo"
                            id="newTodo"
                            name="newTodo"
                            label="Type your task"
                            @keyup.enter="addTodo"
                            :hint="todoExists"
                            persistent-hint
                          />
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-list>
                  <v-card class="mt-4">
                    <v-list subheader two-line flat>
                      <v-list-item-group v-for="(todo, i) in todos" :key="i">
                        <v-hover v-slot="{ hover }">
                          <v-list-item>
                            <template>
                              {{ i + 1 }}
                              <v-list-item-content>
                                <v-list-item-title
                                  :class="{ done: todo.isCompleted }"
                                  >{{
                                    todo.todo | capitalize
                                  }}</v-list-item-title
                                >
                              </v-list-item-content>
                              <v-list-item-action class="ma-5">
                                <v-btn
                                  fab
                                  ripple
                                  small
                                  color="green"
                                  v-if="hover && todo.isCompleted == false"
                                  @click="markAsComplete(todo)"
                                >
                                  <v-icon class="white--text">mdi-check</v-icon>
                                </v-btn>
                                <v-btn
                                  fab
                                  ripple
                                  small
                                  color="red"
                                  v-if="hover && todo.isCompleted == true"
                                  @click="markAsInComplete(todo)"
                                >
                                  <v-icon class="white--text">mdi-close</v-icon>
                                </v-btn>
                              </v-list-item-action>
                              <v-list-item-action>
                                <v-btn
                                  fab
                                  ripple
                                  small
                                  color="blue"
                                  v-if="hover"
                                  @click="onEditItem(todo)"
                                >
                                  <v-icon class="white--text"
                                    >mdi-pencil</v-icon
                                  >
                                </v-btn>
                              </v-list-item-action>
                              <v-list-item-action>
                                <v-btn
                                  fab
                                  ripple
                                  small
                                  color="red"
                                  v-if="hover"
                                  @click="removeTodo(todo)"
                                >
                                  <v-icon class="white--text"
                                    >mdi-delete</v-icon
                                  >
                                </v-btn>
                              </v-list-item-action>
                            </template>
                          </v-list-item>
                        </v-hover>
                        <v-divider
                          v-if="i + 1 < todos.length"
                          :key="i"
                        ></v-divider>
                      </v-list-item-group>
                    </v-list>
                  </v-card>
                </v-card>
              </v-col>
            </v-row>
          </v-container>
        </v-theme-provider>
      </v-main>
    </v-app>
  </div>
</template>
<script>
import axios from "axios";
export default {
  name: "App",
  data() {
    return {
      id: "",
      toDoId: "",
      show: true,
      newTodo: "",
      todos: [],
      isTodoExist: false,
    };
  },
  computed: {
    todoExists() {
      return this.isTodoExist
        ? "todo is already in the list add another one"
        : "";
    },
  },
  mounted() {
    this.getAllTodo();
  },
  methods: {
    getAllTodo() {
      axios.get("http://localhost:8080/api/todo/").then((result) => {
        this.todos = result.data;
      });
    },
    async markAsComplete(item) {
      this.toDoId = item.id;
      await axios
        .put("http://localhost:8080/api/todo/" + this.toDoId, {
          isCompleted: true,
        })
        .then(function (response) {
          console.log(response);
        })
        .catch(function (error) {
          console.log(error);
        });
      this.getAllTodo();
      this.id = "";
      this.toDoId = "";
    },
    async markAsInComplete(item) {
      this.toDoId = item.id;
      await axios
        .put("http://localhost:8080/api/todo/" + this.toDoId, {
          isCompleted: false,
        })
        .then(function (response) {
          console.log(response);
        })
        .catch(function (error) {
          console.log(error);
        });
      this.getAllTodo();
      this.id = "";
      this.toDoId = "";
    },
    async addTodo() {
      this.getAllTodo();
      this.isTodoExist = false;
      const value = this.newTodo && this.newTodo.trim();
      if (!value) {
        return;
      }
      const isTodoExists = this.todos.find((todo) => todo.todo === value);
      if (!isTodoExists) {
        if (this.toDoId) {
          if (this.toDoId !== "") {
            await axios
              .put("http://localhost:8080/api/todo/" + this.toDoId, {
                todo: this.newTodo,
              })
              .then(function (response) {
                console.log(response);
              })
              .catch(function (error) {
                console.log(error);
              });
            this.getAllTodo();
            this.id = "";
            this.toDoId = "";
            this.newTodo = "";
          }
        } else {
          await axios
            .post("http://localhost:8080/api/todo/", {
              todo: this.newTodo,
            })
            .then(function (response) {
              console.log(response);
            })
            .catch(function (error) {
              console.log(error);
            });

          this.getAllTodo();
          this.newTodo = "";
        }
      }
      if (isTodoExists) {
        this.isTodoExist = true;
      }
    },
    onEditItem(item) {
      this.newTodo = item.todo;
      this.toDoId = item.id;
    },

    async removeTodo(index) {
      this.toDoId = index.id;
      await axios.delete("http://localhost:8080/api/todo/" + this.toDoId);
      this.todos.splice(index, 1);
    },
  },

  filters: {
    capitalize: function (value) {
      if (!value) return "";
      value = value.toString();
      return value.charAt(0).toUpperCase() + value.slice(1);
    },
  },
};
</script>
<style>
.done {
  text-decoration: line-through;
}
</style>
